'''Doppelganger race for D&D 3.5 Mod'''

import es, dnds, popuplib, random
from dnds import dnds

def load():
    dnds.addRace('Doppelganger', levelAdjustment=4)
    
    doppelinfo = popuplib.create('doppelinformation')
    doppelinfo.addline('-{ D&D CS:S - Doppelganger Info }-')
    doppelinfo.addline(' Level Adjustment - 4')
    doppelinfo.addline(' Passive Skills:')
    doppelinfo.addline(' - Disguised')
    doppelinfo.addline(' - +5% Speed')
    doppelinfo.addline(' - +10% Damage')
    doppelinfo.addline(' - 10% Damage Reduction')
    doppelinfo.addline(' - +10 Health')
    doppelinfo.addline(' - +10% Cash')
    doppelinfo.addline('-> 8. Back')
    doppelinfo.addline('0. Exit')
    doppelinfo.submenu(8, 'laracesinfo 1')
    dnds.addRaceInformation('Doppelganger', 'doppelinformation', levelAdjustment=4)

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Doppelganger'):
        Key = dnds.getPlayer(userid)
        Key['damage reduction'] += .1
        dnds.Speed(userid, .05)
        dnds.Health(userid, 10)
        dnds.Disguise(userid)
        dnds.Cash(userid, es.getplayerprop(userid,'CCSPlayer.m_iAccount')*.1)

def player_hurt(ev):
    if ev['attacker'] and ev['attacker'] != '0':
        attacker = int(ev['attacker'])
        damage = int(float(ev['dmg_health']))
        if dnds.isRace(attacker, 'Doppelganger'):
            dnds.Damage(ev['userid'], attacker, damage*.1)
