'''A Basic Monster Race for D&D CSS'''

import es, dnds, popuplib
from dnds import dnds

def load():
    dnds.addRace('Vampire', monsterRace=True, bpRequired=10, bonusWeapons=['knife'])
    
    vampireinfo = popuplib.create('vampireinfo')
    vampireinfo.addline('-{ D&D CS:S - Vampire Info }-')
    vampireinfo.addline(' Required Bonus Points: 10')
    vampireinfo.addline(' Weapon: Knife ')
    vampireinfo.addline(' Only Weapon is Visible ')
    vampireinfo.addline(' 1 Health')
    vampireinfo.addline(' Gain Life Equal to Damage Dealt')
    vampireinfo.addline(' Commands:')
    vampireinfo.addline(' - lev0 (Normal Gravity)')
    vampireinfo.addline(' - lev1 (50% Gravity)')
    vampireinfo.addline(' - lev2 (20% Gravity)')
    vampireinfo.addline(' - lev3 (1% Gravity)')
    vampireinfo.addline('-> 8. Back')
    vampireinfo.addline('0. Exit')
    vampireinfo.submenu(8, 'monracesinfo 1')
    dnds.addRaceInformation('vampire', 'vampireinfo', monsterRace=True, bpRequired=10)

    for c in ['lev0', 'lev1', 'lev2', 'lev3']:
        dnds.Commands[c]['Races'].append('Vampire')

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Vampire'):
        dnds.Health(userid, 1, True)
        dnds.Regeneration(userid, 1, 5)

def player_hurt(ev):
    if ev['attacker'] and ev['attacker'] != '0':
        attacker = int(ev['attacker'])
        damage = int(float(ev['dmg_health']))
        if dnds.isRace(attacker, 'Vampire'):
            dnds.Health(attacker, damage)
