'''A Class for D&D 3.5 Mod

To do:
    Finish spells
    Play Test Eveything

Notes -
    Animate dead code is run from the Cleric.py'''

import es, dnds, popuplib, math, gamethread, playerlib, random
from dnds import dnds

SpellCommands = ['missile', 'disguise', 'protection', 'fire', 'haste', 'scry', 'chain', 'massinvis', 'undead', 'time']

def load():
    dnds.addClass('Wizard', dnds.Pistols+['knife'])

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/SubScripts/Wizard/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/SubScripts/Wizard/%s'%command)
    
    dnds.Commands['cast']['Classes'].append('Wizard')

    wizardinfo = popuplib.create('wizardinformation')
    wizardinfo.addline('-{ D&D CS:S - Wizard}-')
    wizardinfo.addline(' Weapons: Pistols')
    wizardinfo.addline(' Enter \'cast\' into chat for a casting menu')
    wizardinfo.addline(' Or enter the (keyword) listed to directly cast a spell')
    wizardinfo.addline('-> 1. Low Level Spells')
    wizardinfo.addline('-> 2. Meduim Level Spells')
    wizardinfo.addline('-> 3. High Level Spells')
    wizardinfo.addline('-> 7. Play as a Wizard')
    wizardinfo.addline('-> 8. Back')
    wizardinfo.addline('0. Exit')
    wizardinfo.submenu(1, 'wizard spinfo 1')
    wizardinfo.submenu(2, 'wizard spinfo 2')
    wizardinfo.submenu(3, 'wizard spinfo 3')
    wizardinfo.submenu(8, 'classinfo 1')
    wizardinfo.menuselect = wizardMenuSelect
    dnds.addClassInformation('Wizard', 'wizardinformation')

    wizardcast = popuplib.create('Wizardcast')
    wizardcast.addline('-{ () Wizard Cast () }-')
    wizardcast.addline('-> 1. Magic Missile')
    wizardcast.addline('-> 2. Disguise Self')
    wizardcast.addline('-> 3. Protection from Bullets')
    wizardcast.addline('-> 4. Fireball')
    wizardcast.addline('-> 5. Haste')
    wizardcast.addline('-> 6. Animate Dead')
    wizardcast.addline('-> 7. Scrying')
    wizardcast.addline('-> 8. Chain Lightning')
    wizardcast.addline('-> 9. High Level Spells')
    wizardcast.addline('0. Exit')
    wizardcast.prepuser = wizardCastPrep
    wizardcast.menuselect = wizardCast

    wizardcast2 = popuplib.create('WizardcastHigh')
    wizardcast2.addline('-{ Wizard High Lvl Castings }-')
    wizardcast2.addline('-> 1. Mass Invisibility')
    wizardcast2.addline('-> 2. Create Greater Undead')
    wizardcast2.addline('-> 3. Time Stop')
    wizardcast2.addline('-> 9. Low Level Spells')
    wizardcast2.addline('0. Exit')
    wizardcast2.submenu(9, 'Wizardcast')
    wizardcast2.prepuser = wizardCastPrepHigh
    wizardcast2.menuselect = wizardCastHigh

    spinfo1 = popuplib.create('wizard spinfo 1')
    spinfo1.addline('-{ Wizard - Low - Spells }-')
    spinfo1.addline(' Magic Missile (lvl 1)')
    spinfo1.addline('  - Damage selected player (missile)')
    spinfo1.addline(' Disguise Self (lvl 1)')
    spinfo1.addline('  -  Appear as the opposite team for a time (disguise)')
    spinfo1.addline(' Protection from Bullets (lvl 3)')
    spinfo1.addline('  -  Selected player gains huge damage reduction for a short time (protection)')
    spinfo1.addline(' Fire Ball (lvl 5)')
    spinfo1.addline('  -  Damage and maybe burn your target and those around them (fire)')
    spinfo1.addline('-> 8. Back')
    spinfo1.addline('0. Exit')
    spinfo1.submenu(8, 'wizardinformation')
    
    spinfo2 = popuplib.create('wizard spinfo 2')
    spinfo2.addline('-{ Wizard - Medium - Spells }-')
    spinfo2.addline(' Haste (lvl 7)')
    spinfo2.addline('  -  Selected player gains a large speed boost (haste)')
    spinfo2.addline(' Animate Dead (lvl 9)')
    spinfo2.addline('  - Raise selected ally as a zombie (500$) (animate)')
    spinfo2.addline(' Scrying (lvl 11)')
    spinfo2.addline('  - Locate nearby enemies for a duration (scry)')
    spinfo2.addline(' Chain Lightning (lvl 13)')
    spinfo2.addline('  - Damage target and link into nearby enemies (chain)')
    spinfo2.addline('-> 8. Back')
    spinfo2.addline('0. Exit')
    spinfo2.submenu(8, 'wizardinformation')
    
    spinfo3 = popuplib.create('wizard spinfo 3')
    spinfo3.addline('-{ Wizard - High - Spells }-')
    spinfo3.addline(' Mass Invisibility (lvl 15)')
    spinfo3.addline('  -  Yourself and all nearby allies vanish fron sight (massinvis)')
    spinfo3.addline(' Create Greater Undead (lvl 17)')
    spinfo3.addline('  -  Raise all dead allies as Shadows (undead)')
    spinfo3.addline(' Time Stop (lvl 19)')
    spinfo3.addline('  -  *Pause* all other players for 5 seconds (time)')
    spinfo3.addline('-> 8. Back')
    spinfo3.addline('0. Exit')
    spinfo3.submenu(8, 'wizardinformation')
    
    dnds.addRace('Shadow', monsterRace=True, bpRequired=0, bonusWeapons=['knife'], menu=False)

def wizardMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Wizard'
        es.tell(userid, '#multi', 'You will be a Wizard once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isClass(userid, 'Wizard'):
        level = dnds.getLevel(userid, 'Wizard')
        Key['spells'][1] += level
        if level >= 7:
            Key['spells'][2] += level/3
        if level >= 13:
            Key['spells'][3] += level/5
    if dnds.isRace(userid, 'Shadow'):
        dnds.Speed(userid, .5)
        es.server.queuecmd('est_setplayercolor %s 0 0 0 40 1'%userid)
        dnds.Health(userid, -50)
        Key['jump'] += .5
        dnds.Gravity(userid, -.3)

def missile():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 1, 1, 'Wizard'):
        dnds.playerMenu(userid, missileSelect, 'Select a player to cast magic missile at', team='other', distance=720)

def missileSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 1, 1, 'Wizard'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 840:
            if not dnds.spellResistance(choice, dnds.getLevel(userid, 'Wizard')):
                dnds.Damage(choice, userid, random.randrange(10, 40, 10))
                es.tell(choice, '#multi', 'You have been hit by a magic missile!')
                es.tell(userid, '#multi', 'You just hit %s with a magic missile!'%es.getplayername(choice))
            else:
                es.tell(userid, '#multi', '%s has resisted your magic missile.'%es.getplayername(choice))
            dnds.spellDelay(userid, 4)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 1
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Magic Missile on.'%es.getplayername(choice))

def disguise():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 1, 1, 'Wizard'):
        dnds.Disguise(userid, max(min(dnds.getLevel(userid, 'Wizard')*5, 30), 10))
        es.tell(userid, '#multi', 'You have disguised yourself for the next %s seconds'%min(dnds.getLevel(userid, 'Wizard')*10, 60))
        dnds.Delayed(userid, min(dnds.getLevel(userid, 'Wizard')*10, 60), es.tell, (userid, '#multi', 'Your disguise has worn off!'))
        dnds.spellDelay(userid, 4)
        Key = dnds.getPlayer(userid)
        Key['spells'][1] -= 1

def protection():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 3, 3, 'Wizard'):
        dnds.playerMenu(userid, protectionSelect, 'Select a player to cast Protection from Bullets on', es.getplayerteam(userid), distance=360, buff='dr')

def protectionSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 3, 3, 'Wizard'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            Key = dnds.getPlayer(choice)
            Key['damage reduction'] += .6
            if userid != choice:
                dnds.giveXp(userid, 15, 'helping an ally')
                es.tell(choice, '#multi', '%s has cast Protection from Bullets on you.'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have cast Protection from Bullets on %s.'%es.getplayername(choice))
            duration = min(dnds.getLevel(userid, 'Wizard')*1.5, 5)
            dnds.Buffs(choice, 'dr', duration)
            dnds.spellDelay(userid, 4)
            dnds.Delayed(choice, duration, protectionEnd, (choice))
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 3
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Protection from Bullets on.'%es.getplayername(choice))

def protectionEnd(userid):
    Key = dnds.getPlayer(userid)
    Key['damage reduction'] -= .6
    es.tell(userid, '#multi', 'Your Protection from Bullets has worn off.')

def fire():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 3, 5, 'Wizard'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, fireRun, (userid))

def fireRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2000:
            dnds.Beam1(userid, target, 1, 255, 0, 0)
            for player in es.getUseridList():
                if not es.getplayerprop(player, "CBasePlayer.pl.deadflag"):
                    x3,y3,z3 = es.getplayerlocation(player)
                    if math.sqrt(math.pow(x3-x2,2)+math.pow(y3-y2,2)+math.pow(z3-z2,2)) <= 240:
                        if target != player:
                            dnds.Beam2(target, player, 1, 255, 0, 0)
                        if not dnds.spellResistance(target, dnds.getLevel(userid, 'Wizard')):
                            dnds.Damage(player, userid, random.randrange(20, 80, 10))
                            es.tell(player, '#multi', 'You have been hit by a fireball!')
                            es.tell(userid, '#multi', 'You have hit %s with a fireball'%es.getplayername(player))
                            if not random.randrange(3):
                                es.server.queuecmd('est_Burn %s %s'%(player, random.randint(2, 7)))
            dnds.spellDelay(userid, 2)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 3

def haste():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 2, 7, 'Wizard'):
        dnds.playerMenu(userid, hasteSelect, 'Select a player to cast Haste on', es.getplayerteam(userid), distance=360, buff='speed')

def hasteSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 2, 2, 7, 'Wizard'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            Key = dnds.getPlayer(userid)
            duration = min(dnds.getLevel(userid, 'Wizard')*.5, 5)
            dnds.Speed(choice, Key['Speed']*.5, delay=duration)
            if userid != choice:
                dnds.giveXp(userid, 20, 'helping an ally')
                es.tell(choice, '#multi', '%s has cast Haste on you.'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have cast Haste on %s.'%es.getplayername(choice))
            dnds.spellDelay(userid, 2)
            dnds.Buffs(choice, 'speed', duration)
            dnds.Delayed(choice, min(dnds.getLevel(userid, 'Wizard')*.5, 5), es.tell, (userid, '#multi', 'Your Haste has worn off.'))
            Key = dnds.getPlayer(userid)
            Key['spells'][2] -= 2
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Haste on.'%es.getplayername(choice))

def scry():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 1, 11, 'Wizard'):
        Key = dnds.getPlayer(userid)
        Key['spells'][2] -= 1
        Key['thermal range'] += 2400
        dnds.spellDelay(userid, 5)
        es.tell(userid, '#multi', 'Nearby enemies are revealed...')
        dnds.Delayed(userid, dnds.getLevel(userid, 'Wizard'), scryOff, (userid))

def scryOff(userid):
    Key = dnds.getPlayer(userid)
    Key['thermal range'] -= 2400
    es.tell(userid, '#multi', 'Your scrying spell has worn off')

def chain():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 3, 13, 'Wizard'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, chainRun, (userid))

def chainRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 3000:
            dnds.Beam1(userid, target, 1, 255, 255, 51)
            if not dnds.spellResistance(target, dnds.getLevel(userid, 'Wizard')):
                chainLoop(userid, dnds.getLevel(userid, 'Wizard'), target)
                dnds.Damage(target, userid, random.randrange(20, 80, 10))
                es.tell(target, '#multi', 'You have been hit by chain lightning!')
                es.tell(userid, '#multi', 'You have hit %s\'s with Chain Lightning'%es.getplayername(target))
            else:
                es.tell(userid, '#multi', '%s has resisted your chain lightning!'%es.getplayername(target))
            dnds.spellDelay(userid, 4)
            Key = dnds.getPlayer(userid)
            Key['spells'][2] -= 3

def chainLoop(userid, jumps, lasthit, targets=[]):
    targets.append(lasthit)
    x1,y1,z1 = es.getplayerlocation(lasthit)
    tohit = []
    for player in es.getUseridList():
        if player not in targets:
            if es.getplayerteam(player) != es.getplayerteam(userid):
                if not es.getplayerprop(player, "CBasePlayer.pl.deadflag"):
                    x2,y2,z2 = es.getplayerlocation(player)
                    if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
                        tohit.append(player)
    if len(tohit) and jumps > 0:
        nexthit = random.choice(tohit)
        if not dnds.spellResistance(nexthit, dnds.getLevel(userid, 'Wizard')):
            dnds.Beam1(lasthit, nexthit, 1, 255, 255, 51)
            dnds.Damage(nexthit, userid, random.randrange(10, 40, 10))
            es.tell(nexthit, '#multi', 'You have been hit by chain lightning!')
            es.tell(userid, '#multi', 'You have hit %s\'s with Chain Lightning'%es.getplayername(nexthit))
            chainLoop(userid, jumps-3, nexthit, targets)
        else:
            es.tell(userid, '#multi', '%s has resisted your chain lightning'%es.getplayername(nexthit))

def massinvis():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 3, 15, 'Wizard'):
        x1,y1,z1 = es.getplayerlocation(userid)
        Key = dnds.getPlayer(userid)
        Key['spells'][3] -= 3
        dnds.spellDelay(userid, 6)
        es.tell(userid, '#multi', 'You have hidden yourself and all nearby allies with Mass Invisibility!')
        for player in es.getUseridList():
            if es.getplayerteam(player) == es.getplayerteam(userid):
                if dnds.Bank(player)['race'] not in ['Ethereal Filcher', 'Vampire']:
                    x2,y2,z2 = es.getplayerlocation(player)
                    if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 480:
                        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 0 1'%player)
                        Key = dnds.getPlayer(player)
                        Key['Invisibility'] = 1
                        if player != userid:
                            es.tell(player, '#multi', '%s has cast mass invisiblity on you.'%es.getplayername(userid))
                        dnds.Delayed(player, dnds.getLevel(userid, 'Wizard')*2, massInvisOff, (player))

def massInvisOff(userid):
    Key = dnds.getPlayer(userid)
    ID = dnds.Bank(userid)
    if es.exists('userid', userid):
        if ID['race'] not in ['Ethereal Filcher', 'Vampire']:
            if Key['Invisibility']:
                Key['Invisibility'] = 0
                es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
                es.tell(userid, '#multi', 'Your invisibility has worn off.')

def undead():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 3, 17, 'Wizard'):
        Key = dnds.getPlayer(userid)
        Key['spells'][3] -= 3
        dnds.spellDelay(userid, 10)
        es.tell(userid, '#multi', 'You have raised an undead army!')
        for player in es.getUseridList():
            if es.getplayerteam(player) == es.getplayerteam(userid):
                if es.getplayerprop(player, "CBasePlayer.pl.deadflag"):
                    undeadTarget(player)
                    es.tell(player, '#multi', 'You have been raised as a Shadow by %s'%es.getplayername(userid))

def undeadTarget(userid):
    target = userid
    Key = dnds.getPlayer(target)
    Key['undead'] = True
    ID = dnds.Bank(target)
    Class = ID['class']
    prestige = ID['prestige']
    race = ID['race']
    Key['undead'] = [race, Class, prestige]
    Key['delayed']['class'] = Class
    Key['delayed']['prestige'] = prestige
    Key['delayed']['race'] = race
    ID['class'] = None
    ID['prestige'] = None
    ID['race'] = 'Shadow'
    x,y,z = Key['death location']
    es.server.queuecmd('est_Spawn %s'%target)
    es.server.queuecmd('es_xsetpos %s %s %s %s'%(target, x, y, z))

def time():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 3, 19, 'Wizard'):
        es.msg('#multi', '#green%s has stopped time for a few moments, hang tight while they have their way with the world.'%es.getplayername(userid))
        Key = dnds.getPlayer(userid)
        Key['spells'][3] -= 3
        dnds.spellDelay(userid, 10)
        for player in es.getUseridList():
            if player != userid:
                dnds.Freeze(player, 10)
                dnds.Blind(player, 10)
                dnds.getPlayer(player)['damage reduction'] += 1
                dnds.Delayed(player, 10, timeOff, (player))

def timeOff(userid):
    dnds.getPlayer(userid)['damage reduction'] -= 1

def wizardCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'missile')
    elif choice == 2:
        es.cexec(userid, 'disguise')
    elif choice == 3:
        es.cexec(userid, 'protection')
    elif choice == 4:
        es.cexec(userid, 'fire')
    elif choice == 5:
        es.cexec(userid, 'haste')
    elif choice == 6:
        es.cexec(userid, 'animate')
    elif choice == 7:
        es.cexec(userid, 'scry')
    elif choice == 8:
        es.cexec(userid, 'chain')
    elif choice == 9 and dnds.getLevel(userid, 'Wizard') >= 15:
        dnds.popupSend('WizardcastHigh', userid)
    elif choice == 9 and dnds.Bank(userid)['prestige']:
        dnds.popupSend('%scast'%dnds.Bank(userid)['prestige'], userid)

def wizardCastPrep(userid, popupid):
    popup = popuplib.find('Wizardcast')
    level = dnds.getLevel(userid, 'Wizard')
    Key = dnds.getPlayer(userid)
    ID = dnds.Bank(userid)
    prestige = ID['prestige']
    popup.modline(1, '-{ Wizard Cast - %sL - %sM }-'%(Key['spells'][1], Key['spells'][2]))
    if Key['spells'][1] < 1:
        popup.modline(2, ' Magic Missile')
        popup.modline(3, ' Disguise Self')
    else:
        popup.modline(2, '-> 1. Magic Missile 1L')
        popup.modline(3, '-> 2. Disguise Self 1L')
    if level < 3:
        popup.modline(4, '')
    else:
        if Key['spells'][1] < 3:
            popup.modline(4, ' Protection from Bullets')
        else:
            popup.modline(4, '-> 3. Protection from Bullets 3L')
    if level < 5:
        popup.modline(5, '')
    else:
        if Key['spells'][1] < 3:
            popup.modline(5, ' Fireball')
        else:
            popup.modline(5, '-> 4. Fireball 3L')
    if level < 7:
        popup.modline(6, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(6, ' Haste')
        else:
            popup.modline(6, '-> 5. Haste 2M')
    if level < 9:
        popup.modline(7, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(7, ' Animate Dead')
        else:
            popup.modline(7, '-> 6. Animate Dead 2M')
    if level < 11:
        popup.modline(8, '')
    else:
        if Key['spells'][2] < 1:
            popup.modline(8, ' Scrying')
        else:
            popup.modline(8, '-> 7. Scrying 1M')
    if level < 13:
        popup.modline(9, '')
    else:
        if Key['spells'][2] < 3:
            popup.modline(9, ' Chain Lightning')
        else:
            popup.modline(9, '-> 8. Chain Lightning 3M')
    if level < 15:
        popup.modline(10, '')
    else:
        popup.modline(10, '-> 9. High Level Spells')
    if prestige:
        popup.modline(10, '-> 9. Prestige Spells')

def wizardCastHigh(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'massinvis')
    elif choice == 2:
        es.cexec(userid, 'undead')
    elif choice == 3:
        es.cexec(userid, 'time')

def wizardCastPrepHigh(userid, popupid):
    popup = popuplib.find('WizardcastHigh')
    level = dnds.getLevel(userid, 'Wizard')
    Key = dnds.getPlayer(userid)
    if level < 15:
        popup.modline(2, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(2, ' Mass Invisibility')
        else:
            popup.modline(2, '-> 1. Mass Invisibility')
    if level < 17:
        popup.modline(3, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(3, ' Create Greater Undead')
        else:
            popup.modline(3, '-> 2. Create Greater Undead')
    if level < 19:
        popup.modline(4, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(4, ' Time Stop')
        else:
            popup.modline(4, '-> 3. Time Stop')
